<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use Illuminate\Support\Facades\Hash;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Log;
use App\Models\Parents;
use App\Models\User;
use App\Models\Role;

class ParentsController extends Controller
{
    public function store(Request $request)
    {
        DB::beginTransaction();
        
        try {
            $role = Role::where(['name' => 'parent'])->first();
            $user = User::create([
                'name' => $request->name,
                'email' => $request->email,
                'email_verified_at' => now(),
                'password' => Hash::make('password'),
            ]);
            $user->roles()->attach($role->id);

            Parents::create([
                'name' => $request->name,
                'user_id' => $user->id,
                'nric' => $request->nric,
                'email' => $request->email,
                'phone' => $request->phone,
            ]);

            DB::commit();
            return response()->json(['result' => 'ok']);
        } catch (\Exception $e) {
            DB::rollback();
            Log::error($e->getMessage());
            return response()->json(['error' => $e->getMessage()], 500);
        }
    }
    
    public function update(Request $request)
    {
        DB::beginTransaction();
        try {
            Parents::where('nric', $request->nric)
                ->update([
                    'name' => $request->name,
                    'email' => $request->email,
                    'phone' => $request->phone,
                ]);
                
            $user = User::where(['email' => $request->email])->first();
            $user->name = $request->name;
            $user->save();
            DB::commit();

            return response()->json(['result' => 'ok']);
        } catch (\Exception $e) {
            DB::rollback();
            Log::error($e->getMessage());
            return response()->json(['error' => $e->getMessage()], 500);
        }
    }
}
