<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use Illuminate\Support\Facades\Storage;
use SimpleSoftwareIO\QrCode\Facades\QrCode;

class QRCodeController extends Controller
{
    /**
     * Show the QR Code generation page.
     *
     * @return \Illuminate\Contracts\Support\Renderable
     */
    public function index()
    {
        return view('qrcode');
    }

    /**
     * Generate and download QR Code.
     *
     * @param Request $request
     * @return \Symfony\Component\HttpFoundation\BinaryFileResponse
     */
    public function downloadQrCode(Request $request)
    {
        $data = $request->input('data');
        $fileName = 'qrcode.png';

        $qrCode = QrCode::format('png')
            ->size(300)
            ->generate($data, storage_path("app/public/$fileName"));

        return response()->download(storage_path("app/public/$fileName"), $fileName);
    }
}