<?php

namespace App\Http\Controllers;

use App\Models\Student;
use App\Models\Parents;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\DB;

class StudentController extends Controller
{
    public function store(Request $request)
    {
        try {
            $parent = Parents::where('name', $request->parent_id)->firstOrFail();
            
            Student::create([
                'name' => $request->name,
                'parent_id' => $parent->id,
                'idno' => $request->idno,
                'class_year' => $request->class_year,
                'class_name' => $request->class_name,
            ]);

            return response()->json(['result' => 'ok']);
        } catch (\Exception $e) {
            return response()->json(['error' => $e->getMessage()], 500);
        }
    }
    
    public function update(Request $request)
    {
        try {
            $parent = Parents::where('name', $request->parent_id)->firstOrFail();
            Student::where('idno', $request->idno)
                ->update([
                    'name' => $request->name,
                    'parent_id' => $parent->id,
                    'idno' => $request->idno,
                    'class_year' => $request->class_year,
                    'class_name' => $request->class_name,
                ]);

            return response()->json(['result' => 'ok']);
        } catch (\Exception $e) {
            return response()->json(['error' => $e->getMessage()], 500);
        }
    }
}