<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use Illuminate\Support\Facades\Http;
use Illuminate\Support\Facades\Validator;
use Illuminate\Support\Str;
use Illuminate\Support\Facades\Log;

class WalletController extends Controller
{

    public function reload(Request $request) {
        $validator = Validator::make($request->all(), [
            'buyer_name' => 'required',
            'buyer_email' => 'required',
            'buyer_phone' => 'required',
            'transaction_amount' => 'required',
            'product_description' => 'required'
        ]);

        if ($validator->fails()) {
           return response()->json([ 'Message' => 'Required fields not completed', 'Errors' => $validator->errors() ], 500);
        }

        $order_number = Str::random(10);
        $buyer_name = $request->buyer_name;
        $buyer_email = $request->buyer_email;
        $buyer_phone = $request->buyer_phone;
        $transaction_amount = $request->transaction_amount;
        $product_description = $request->product_description;
        $uid = "09cfa17c-47a3-4efa-b017-1f1c256ac3a7";
        $auth_token = "-h3qnSkbeHZBajXY4zGj";
        $checksum_token = "e4d4f2959751ee190813cf5749acd7957e373dfd6ea75ddc61b03eda11f5ab94";
        $callback_url = "https://smartschool.gngsoftech.com/callback";
        $redirect_url = "https:/smartschool.gngsoftech.com/redirect";
        $cancel_url = "https://smartschool.gngsoftech.com/cancel";
        $timeout_url = "https://smartschool.gngsoftech.com/timeout";
        $redirect_post = "true";
        $post_string = $buyer_email."|".$buyer_name."|".$buyer_phone."|".$callback_url."|".$order_number."|".$product_description."|".$redirect_url."|".$transaction_amount."|".$uid;
        $signed_post_string = hash_hmac('sha256', $post_string, $checksum_token);
        $buyer_name = urlencode($buyer_name);
        $auth_token = urlencode($auth_token);
        $callback_url = urlencode($callback_url);
        $redirect_url = urlencode($redirect_url);
        $order_number = urlencode($order_number);
        $buyer_email = urlencode($buyer_email);
        $buyer_phone = urlencode($buyer_phone);
        $transaction_amount = urlencode($transaction_amount);
        $product_description = urlencode($product_description);
        $redirect_post = urlencode($redirect_post);
        $signed_post_string = urlencode($signed_post_string);
        $post_data = "buyer_name=".$buyer_name."&token=". $auth_token."&callback_url="
            .$callback_url."&redirect_url=". $redirect_url ."&order_number="
            .$order_number."&buyer_email=".$buyer_email."&buyer_phone="
            .$buyer_phone."&transaction_amount=".$transaction_amount
            ."&product_description=".$product_description."&redirect_post="
            .$redirect_post."&checksum=".$signed_post_string;
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, "https://securepay.my/api/v1/payments");
        curl_setopt($ch, CURLOPT_POST, 1);
        curl_setopt($ch, CURLOPT_POSTFIELDS,$post_data);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_exec($ch);
        $output = curl_exec($ch);
        return $output;

        
    }
    
    public function reloadTest(Request $request) {
        
        $order_number = Str::random(10);
        $buyer_name = "tester";
        $buyer_email = "test@example.com";
        $buyer_phone = "0123456789";
        $transaction_amount = "5.00";
        $product_description = "testing";
        $uid = "09cfa17c-47a3-4efa-b017-1f1c256ac3a7";
        $auth_token = "-h3qnSkbeHZBajXY4zGj";
        $checksum_token = "e4d4f2959751ee190813cf5749acd7957e373dfd6ea75ddc61b03eda11f5ab94";
        $callback_url = "https://smartschool.gngsoftech.com/callback";
        $redirect_url = "https:/smartschool.gngsoftech.com/redirect";
        $cancel_url = "https://smartschool.gngsoftech.com/cancel";
        $timeout_url = "https://smartschool.gngsoftech.com/timeout";
        $redirect_post = "true";
        $post_string = $buyer_email."|".$buyer_name."|".$buyer_phone."|".$callback_url."|".$order_number."|".$product_description."|".$redirect_url."|".$transaction_amount."|".$uid;
        $signed_post_string = hash_hmac('sha256', $post_string, $checksum_token);
        $buyer_name = urlencode($buyer_name);
        $auth_token = urlencode($auth_token);
        $callback_url = urlencode($callback_url);
        $redirect_url = urlencode($redirect_url);
        $order_number = urlencode($order_number);
        $buyer_email = urlencode($buyer_email);
        $buyer_phone = urlencode($buyer_phone);
        $transaction_amount = urlencode($transaction_amount);
        $product_description = urlencode($product_description);
        $redirect_post = urlencode($redirect_post);
        $signed_post_string = urlencode($signed_post_string);
        $post_data = "buyer_name=".$buyer_name."&token=". $auth_token."&callback_url="
            .$callback_url."&redirect_url=". $redirect_url ."&order_number="
            .$order_number."&buyer_email=".$buyer_email."&buyer_phone="
            .$buyer_phone."&transaction_amount=".$transaction_amount
            ."&product_description=".$product_description."&redirect_post="
            .$redirect_post."&checksum=".$signed_post_string;
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, "https://sandbox.securepay.my/api/v1/payments");
        curl_setopt($ch, CURLOPT_POST, 1);
        curl_setopt($ch, CURLOPT_POSTFIELDS,$post_data);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_exec($ch);
        $output = curl_exec($ch);
        return $output;

        
    }

    public function redirect(Request $request) {
        Log::debug($request->all());
        if(!is_null($request) && $request->payment_status == 'true') {
            return view('redirect', ['status' => 1, 'ref' => $request->merchant_reference_number, 
                'email' => $request->buyer_email, 'phone' => $request->buyer_phone, 
                'receipt' => $request->receipt_url, 'amount' => $request->transaction_amount]);
        }

        else if(!is_null($request) && $request->payment_status == 'false') {
            return view('redirect', ['status' => 0, 'ref' => $request->merchant_reference_number, 
                'email' => $request->buyer_email, 'phone' => $request->buyer_phone, 
                'retry' => $request->retry_url, 'amount' => $request->transaction_amount]);
        }
    }

    public function callback(Request $request) {
        Log::debug($request);
        try {
            $data = $request->except(['id']);
            $consumer_id = substr($data['order_number'], 10);
            $data['consumer_id'] = $consumer_id;
            $balance = '';
        }

        catch(Exception $exception) {
            Log::debug($exception);

        }
        
        return 200;
    }
}