<?php

namespace App\Http\Livewire;

use Illuminate\Support\Facades\Storage;
use Livewire\Component;
use SimpleSoftwareIO\QrCode\Facades\QrCode;
use App\Models\Student;

class TableComponent extends Component
{
    public $selectedRows = [];
    public $rows;

    public function mount()
    {
        $this->rows = Student::all();
    }

    public function render()
    {
        $data = [
            ['name' => 'John Doe', 'id' => '12345', 'class' => 'Grade 1'],
            ['name' => 'Jane Smith', 'id' => '67890', 'class' => 'Grade 2'],
            ['name' => 'Bob Johnson', 'id' => '54321', 'class' => 'Grade 3'],
        ];

        return view('livewire.table-component', [
            'data' => $this->rows,
        ]);
    }

    public function toggleRowSelection($id)
    {
        if (in_array($id, $this->selectedRows)) {
            $this->selectedRows = array_diff($this->selectedRows, [$id]);
        } else {
            $this->selectedRows[] = $id;
        }
    }

    public function downloadQrCodes()
    {
        $fileName = '';
        foreach ($this->selectedRows as $id) {
            $qrCodePath = "qrcode_$id.png";
            $fileName = $qrCodePath;
            QrCode::format('png')
                ->size(300)
                ->generate($id, storage_path("app/public/$qrCodePath"));
            
        }

        return response()->download(storage_path("app/public/$fileName"), $fileName);
    }

    // public function downloadQrCodes()
    // {
    //     $fileName = 'qrcode_batch.zip';

    //     $zip = new \ZipArchive();
    //     $zip->open(storage_path("app/public/$fileName"), \ZipArchive::CREATE | \ZipArchive::OVERWRITE);

    //     foreach ($this->selectedRows as $id) {
    //         $qrCodePath = "qrcode_$id.png";
    //         QrCode::format('png')
    //             ->size(300)
    //             ->generate($id, storage_path("app/public/$qrCodePath"));
    //         $zip->addFile(storage_path("app/public/$qrCodePath"), $qrCodePath);
    //     }

    //     $zip->close();

    //     return response()->download(storage_path("app/public/$fileName"), $fileName);
    // }
}