<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Student extends Model
{
    use HasFactory;

    protected $table = 'students';

    protected $fillable = [
        'parent_id',
        'name',
        'idno',
        'class_year',
        'class_name',
        'created_at',
        'updated_at',
    ];

    protected $casts = [
        'class_year' => 'integer',
        'created_at' => 'datetime',
        'updated_at' => 'datetime',
    ];
    
    public function parent()
    {
        return $this->belongsTo(Parents::class, 'parent_id');
    }
}
