<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

return new class extends Migration
{
    /**
     * Run the migrations.
     */
    public function up(): void
    {
        Schema::create('teachers', function (Blueprint $table) {
            $table->id('id')->primary();
            $table->unsignedBigInteger('user_id')->nullable(false);
            $table->string('name', 128)->nullable(false);
            $table->string('nric', 12)->nullable(false);
            $table->string('email', 50)->nullable(false);
            $table->boolean('standard_year')->nullable();
            $table->string('class_name', 20)->nullable();
            $table->string('society_name', 50)->nullable();
            $table->string('sport_name', 50)->nullable();
            $table->foreign('user_id')->references('id')->on('users');
            $table->timestamps();
        });
    }

    /**
     * Reverse the migrations.
     */
    public function down(): void
    {
        Schema::dropIfExists('teachers');
    }
};
