<?php

use App\Http\Controllers\Api\AuthController;
use App\Http\Controllers\AttendanceController;

Route::prefix('auth')->group(function () {
    Route::post('register', [AuthController::class, 'register']);
    Route::post('login', [AuthController::class, 'login']);
    
    Route::middleware('auth:sanctum')->group(function () {
        Route::post('logout', [AuthController::class, 'logout']);
        Route::get('user', [AuthController::class, 'getUser']);
        Route::post('attendance', [AttendanceController::class, 'store']);
        Route::get('attendance/student/{student_id}', [AttendanceController::class, 'getAttendanceByStudent']);
        Route::get('attendance', [AttendanceController::class, 'getAllAttendance']);
        Route::get('attendance/status', [AttendanceController::class, 'getAttendanceStatus']);
    });
});
