<?php

use App\Http\Controllers\ProfileController;
use App\Http\Controllers\WalletController;
use App\Http\Controllers\ParentsController;
use App\Http\Controllers\StudentController;
use App\Http\Controllers\TeacherController;
use App\Http\Controllers\GeneralController;
use Illuminate\Support\Facades\Route;

Route::get('/', function () {
    return view('welcome');
});

Route::get('/dashboard', function () {
    return view('dashboard');
})->middleware(['auth', 'verified'])->name('dashboard');

Route::get('/qrcode', function () {
    return view('qrcode');
})->middleware(['auth', 'verified'])->name('qrcode');

Route::middleware('auth')->group(function () {
    Route::get('/profile', [ProfileController::class, 'edit'])->name('profile.edit');
    Route::patch('/profile', [ProfileController::class, 'update'])->name('profile.update');
    Route::delete('/profile', [ProfileController::class, 'destroy'])->name('profile.destroy');
});

//public API securepay callback routes
Route::post('/redirect', [WalletController::class, 'redirect']);
Route::post('/callback', [WalletController::class, 'callback']);
Route::post('/topup', [WalletController::class, 'reload']);
Route::get('/topup/test', [WalletController::class, 'reloadTest']);

//general public route
Route::prefix('/general')->group(function () {
    Route::get('test', function() {
        return response('Hello World', 200)->header('Content-Type', 'text/plain');
    });
    Route::get('check/{table}/{column}/{value?}', [GeneralController::class, 'checkRow']);
    //Route::post('create/teachers', [TeacherController::class, 'store']);
    Route::post('create/parents', [ParentsController::class, 'store']);
    Route::post('create/students', [StudentController::class, 'store']);
    //Route::post('create/students', [StudentController::class, 'store']);
    //Route::put('update/teachers', [TeacherController::class, 'update']);
    Route::put('update/parents', [ParentsController::class, 'update']);
    Route::put('update/students', [StudentController::class, 'update']);
});

require __DIR__.'/auth.php';
require __DIR__.'/api.php';
